searchNodes=[{"doc":"VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features:Ethernet and WiFi support included. Extendible to other technologiesDefault configurations specified in your Application configRuntime updates to configurations are persisted and applied on next boot (can be disabled)Simple subscription to network status change eventsConnect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular)Internet connection monitoring and failure detection (currently slow and simplistic)See github.com/nerves-networking/vintage_net for more information.","ref":"VintageNet.html","title":"VintageNet","type":"module"},{"doc":"Return a list of all interfaces on the system","ref":"VintageNet.html#all_interfaces/0","title":"VintageNet.all_interfaces/0","type":"function"},{"doc":"Check if this is a valid configurationThis runs the validation routines for a settings map, but doesn't try to apply them.","ref":"VintageNet.html#configuration_valid?/2","title":"VintageNet.configuration_valid?/2","type":"function"},{"doc":"Update the configuration of a network interfaceConfigurations are validated and normalized before being applied. This means that type errors and missing required fields will be caught and old or redundant ways of specifying configurations will be fixed. Call get_configuration/1 to see how what changes, if any, were made as part of the normalization process.After validation, the configuration is optionally persisted and applied.See the VintageNet documentation for configuration examples or your VintageNet.Technology provider's docs.Options::persist - set to false to avoid persisting this configuration. System restarts will revert to the previous configuration.","ref":"VintageNet.html#configure/3","title":"VintageNet.configure/3","type":"function"},{"doc":"Return a list of configured interface","ref":"VintageNet.html#configured_interfaces/0","title":"VintageNet.configured_interfaces/0","type":"function"},{"doc":"Deconfigure settings for a specified interface.Supports same options as configure/3","ref":"VintageNet.html#deconfigure/2","title":"VintageNet.deconfigure/2","type":"function"},{"doc":"Get the current value of a network propertySee get_by_prefix/1 for exact prefix matches (i.e., get all properties for one interface) and match/1 to run wildcard matches (i.e., get a specific property for all interfaces).","ref":"VintageNet.html#get/2","title":"VintageNet.get/2","type":"function"},{"doc":"Get a list of all properties matching the specified prefixTo get a list of all known properties and their values, call VintageNet.get_by_prefix([])","ref":"VintageNet.html#get_by_prefix/1","title":"VintageNet.get_by_prefix/1","type":"function"},{"doc":"Return the settings for the specified interface","ref":"VintageNet.html#get_configuration/1","title":"VintageNet.get_configuration/1","type":"function"},{"doc":"Print the current network statusOptions include::redact - Set to false to print out passwords","ref":"VintageNet.html#info/1","title":"VintageNet.info/1","type":"function"},{"doc":"Run a command on a network interfaceCommands are mostly network interface-specific. Also see the VintageNet PropertyTable fo getting status or registering for status changes.","ref":"VintageNet.html#ioctl/3","title":"VintageNet.ioctl/3","type":"function"},{"doc":"Get a list of all properties matching a patternPatterns are list of strings that optionally specify :_ at a position in the list to match any value.","ref":"VintageNet.html#match/1","title":"VintageNet.match/1","type":"function"},{"doc":"Return the maximum number of interfaces controlled by VintageNetInternal constraints mean that VintageNet can't manage an arbitrary number of interfaces and knowing the max can reduce some processing. The limit is set by the application config. Unless you need over 100 network interfaces, VintageNet's use of the Linux networking API is not likely to be an issue, though.","ref":"VintageNet.html#max_interface_count/0","title":"VintageNet.max_interface_count/0","type":"function"},{"doc":"Initiate an access point scan on a wireless interfaceThe scan results are posted asynchronously to the [&quot;interface&quot;, ifname, &quot;wifi&quot;, &quot;access_points&quot;] property as they come in. It appears that there's some variation in how scanning is implemented on WiFi adapters. One strategy that seems to work is to call scan/1 every 10 seconds or so while prompting a user to pick a WiFi network.This is a utility function for calling the :scan ioctl.","ref":"VintageNet.html#scan/1","title":"VintageNet.scan/1","type":"function"},{"doc":"Subscribe to property change messagesMessages have the form:{VintageNet, property_name, old_value, new_value, metadata}Subscriptions are prefix matches. For example, to get notified whenever a property changes on &quot;wlan0&quot;, run this:VintageNet.subscribe([&quot;interface&quot;, &quot;wlan0&quot;])It's also possible to match with wildcards using :_. For example, to get notified whenever an IP address in the system changes, do this:VintageNet.subscribe([&quot;interface&quot;, :_, &quot;addresses&quot;])","ref":"VintageNet.html#subscribe/1","title":"VintageNet.subscribe/1","type":"function"},{"doc":"Stop subscribing to property change messages","ref":"VintageNet.html#unsubscribe/1","title":"VintageNet.unsubscribe/1","type":"function"},{"doc":"Check that the system has the required programs installedNOTE: This isn't completely implemented yet!","ref":"VintageNet.html#verify_system/1","title":"VintageNet.verify_system/1","type":"function"},{"doc":"IP addresses in VintageNet can be specified as strings or tuplesWhile VintageNet uses IP addresses in tuple form internally, it can be cumbersome to always convert to tuple form in practice. The general rule is that VintageNet is flexible in how it accepts IP addresses, but if you get an address from a VintageNet API, it will be in tuple form.","ref":"VintageNet.html#t:any_ip_address/0","title":"VintageNet.any_ip_address/0","type":"type"},{"doc":"Valid options for VintageNet.configure/3:persist - Whether or not to save the configuration (defaults to true)","ref":"VintageNet.html#t:configure_options/0","title":"VintageNet.configure_options/0","type":"type"},{"doc":"A name for the network interfaceNames depend on the device drivers and any software that may rename them. Typical names on Nerves are:&quot;eth0&quot;, &quot;eth1&quot;, etc. for wired Ethernet interfaces&quot;wlan0&quot;, etc. for WiFi interfaces&quot;ppp0&quot; for cellular modems&quot;usb0&quot; for gadget USB virtual Ethernet interfaces","ref":"VintageNet.html#t:ifname/0","title":"VintageNet.ifname/0","type":"type"},{"doc":"Valid options for VintageNet.info/1:redact - Whether to hide passwords and similar information from the output (defaults to true)","ref":"VintageNet.html#t:info_options/0","title":"VintageNet.info_options/0","type":"type"},{"doc":"The number of bits to use for an IPv4 subnetFor example, if you have a subnet mask of 255.255.255.0, then the prefix length would be 24.","ref":"VintageNet.html#t:ipv4_prefix_length/0","title":"VintageNet.ipv4_prefix_length/0","type":"type"},{"doc":"The number of bits to use for an IPv6 subnet","ref":"VintageNet.html#t:ipv6_prefix_length/0","title":"VintageNet.ipv6_prefix_length/0","type":"type"},{"doc":"The number of IP address bits for the subnet","ref":"VintageNet.html#t:prefix_length/0","title":"VintageNet.prefix_length/0","type":"type"},{"doc":"This module contains utilities for handling IP addresses.By far the most important part of handling IP addresses is to pay attention to whether your addresses are names, IP addresses as strings or IP addresses at tuples. This module doesn't resolve names. While IP addresses in string form are convenient to type, nearly all Erlang and Elixir code uses IP addresses in tuple form.","ref":"VintageNet.IP.html","title":"VintageNet.IP","type":"module"},{"doc":"Convert an IP address w/ prefix to a CIDR-formatted stringExamples:iex&gt; VintageNet.IP.cidr_to_string({192, 168, 0, 1}, 24) &quot;192.168.0.1/24&quot;","ref":"VintageNet.IP.html#cidr_to_string/2","title":"VintageNet.IP.cidr_to_string/2","type":"function"},{"doc":"Convert an IP address to a stringExamples:iex&gt; VintageNet.IP.ip_to_string({192, 168, 0, 1}) &quot;192.168.0.1&quot; iex&gt; VintageNet.IP.ip_to_string(&quot;192.168.9.1&quot;) &quot;192.168.9.1&quot; iex&gt; VintageNet.IP.ip_to_string({65152, 0, 0, 0, 0, 0, 0, 1}) &quot;fe80::1&quot;","ref":"VintageNet.IP.html#ip_to_string/1","title":"VintageNet.IP.ip_to_string/1","type":"function"},{"doc":"Convert an IP address to tuple formExamples:iex&gt; VintageNet.IP.ip_to_tuple(&quot;192.168.0.1&quot;) {:ok, {192, 168, 0, 1}} iex&gt; VintageNet.IP.ip_to_tuple({192, 168, 1, 1}) {:ok, {192, 168, 1, 1}} iex&gt; VintageNet.IP.ip_to_tuple(&quot;fe80::1&quot;) {:ok, {65152, 0, 0, 0, 0, 0, 0, 1}} iex&gt; VintageNet.IP.ip_to_tuple({65152, 0, 0, 0, 0, 0, 0, 1}) {:ok, {65152, 0, 0, 0, 0, 0, 0, 1}} iex&gt; VintageNet.IP.ip_to_tuple(&quot;bologna&quot;) {:error, &quot;Invalid IP address: bologna&quot;}","ref":"VintageNet.IP.html#ip_to_tuple/1","title":"VintageNet.IP.ip_to_tuple/1","type":"function"},{"doc":"Raising version of ip_to_tuple/1","ref":"VintageNet.IP.html#ip_to_tuple!/1","title":"VintageNet.IP.ip_to_tuple!/1","type":"function"},{"doc":"Convert an IPv4 or IPv6 prefix length to a subnet mask.Examples:iex&gt; VintageNet.IP.prefix_length_to_subnet_mask(:inet, 24) {255, 255, 255, 0} iex&gt; VintageNet.IP.prefix_length_to_subnet_mask(:inet, 28) {255, 255, 255, 240} iex&gt; VintageNet.IP.prefix_length_to_subnet_mask(:inet6, 64) {65535, 65535, 65535, 65535, 0, 0, 0, 0}","ref":"VintageNet.IP.html#prefix_length_to_subnet_mask/2","title":"VintageNet.IP.prefix_length_to_subnet_mask/2","type":"function"},{"doc":"Convert an IPv4 subnet mask to a prefix length.Examples:iex&gt; VintageNet.IP.subnet_mask_to_prefix_length({255, 255, 255, 0}) {:ok, 24} iex&gt; VintageNet.IP.subnet_mask_to_prefix_length({192, 168, 1, 1}) {:error, &quot;{192, 168, 1, 1} is not a valid IPv4 subnet mask&quot;}","ref":"VintageNet.IP.html#subnet_mask_to_prefix_length/1","title":"VintageNet.IP.subnet_mask_to_prefix_length/1","type":"function"},{"doc":"Utility function to trim an IP address to its subnetExamples:iex&gt; VintageNet.IP.to_subnet({192, 168, 1, 50}, 24) {192, 168, 1, 0} iex&gt; VintageNet.IP.to_subnet({192, 168, 255, 50}, 22) {192, 168, 252, 0} iex&gt; VintageNet.IP.to_subnet({64768, 43690, 0, 0, 4144, 58623, 65276, 33158}, 64) {64768, 43690, 0, 0, 0, 0, 0, 0}","ref":"VintageNet.IP.html#to_subnet/2","title":"VintageNet.IP.to_subnet/2","type":"function"},{"doc":"This is a helper module for VintageNet.Technology implementations that use a DHCP server.DHCP server parameters are::start - Start of the lease block:end - End of the lease block:max_leases - The maximum number of leases:decline_time - The amount of time that an IP will be reserved (leased to nobody):conflict_time -The amount of time that an IP will be reserved:offer_time - How long an offered address is reserved (seconds):min_lease - If client asks for lease below this value, it will be rounded up to this value (seconds):auto_time - The time period at which udhcpd will write out leases file.:static_leases - list of {mac_address, ip_address}:options - a map DHCP response options to set. See below.DHCP response options are (see RFC 2132 for details)::dns - IP_LIST:domain - STRING - [0x0f] client's domain suffix:hostname - STRING:mtu - NUM:router - IP_LIST:search - STRING_LIST - [0x77] search domains:serverid - IP (defaults to the interface's IP address):subnet - IPOptions may also be passed in as integers. These are passed directly to the DHCP server and their values are strings that are not interpreted by VintageNet. Use this to support custom DHCP header options.","ref":"VintageNet.IP.DhcpdConfig.html","title":"VintageNet.IP.DhcpdConfig","type":"module"},{"doc":"Add udhcpd configuration commands for running a DHCP server","ref":"VintageNet.IP.DhcpdConfig.html#add_config/3","title":"VintageNet.IP.DhcpdConfig.add_config/3","type":"function"},{"doc":"Normalize the DHCPD parameters in a configuration.","ref":"VintageNet.IP.DhcpdConfig.html#normalize/1","title":"VintageNet.IP.DhcpdConfig.normalize/1","type":"function"},{"doc":"This is a helper module for VintageNet.Technology implementations that use the Busybox DNS server.DNS functionality is only supported for IPv4 configurations using static IP addresses.DNS server parameters are::port - The port to use (defaults to 53):ttl - DNS record TTL in seconds (defaults to 120):records - DNS A records (required)The :records option is a list of name/IP address tuples. For example:[{&quot;example.com&quot;, {1, 2, 3, 4}}]Only IPv4 addresses are supported. Addresses may be specified as strings or tuples, but will be normalized to tuple form before being applied.","ref":"VintageNet.IP.DnsdConfig.html","title":"VintageNet.IP.DnsdConfig","type":"module"},{"doc":"Add dnsd configuration commands for running a DNSD server","ref":"VintageNet.IP.DnsdConfig.html#add_config/3","title":"VintageNet.IP.DnsdConfig.add_config/3","type":"function"},{"doc":"Normalize the DNSD parameters in a configuration.","ref":"VintageNet.IP.DnsdConfig.html#normalize/1","title":"VintageNet.IP.DnsdConfig.normalize/1","type":"function"},{"doc":"This is a helper module for VintageNet.Technology implementations that use IPv4.IPv4 configuration is specified under the :ipv4 key in the configuration map. Fields include::method - :dhcp, :static, or :disabledThe :dhcp method currently has no additional fields.The :static method uses the following fields::address - the IP address:prefix_length - the number of bits in the IP address to use for the subnet (e.g., 24):netmask - either this or prefix_length is used to determine the subnet. If you have a choice, use prefix_length:gateway - the default gateway for this interface (optional):name_servers - a list of DNS servers (optional):domain - DNS search domain (optional)Configuration normalization converts :netmask to :prefix_length.","ref":"VintageNet.IP.IPv4Config.html","title":"VintageNet.IP.IPv4Config","type":"module"},{"doc":"Add IPv4 configuration commands for supporting static and dynamic IP addressing","ref":"VintageNet.IP.IPv4Config.html#add_config/3","title":"VintageNet.IP.IPv4Config.add_config/3","type":"function"},{"doc":"Normalize the IPv4 parameters in a configuration.","ref":"VintageNet.IP.IPv4Config.html#normalize/1","title":"VintageNet.IP.IPv4Config.normalize/1","type":"function"},{"doc":"Manage a network interface at a very high levelThis module handles configuring network interfaces, making sure that configuration failures get retried, and then cleaning up after it's not needed.The actual code that supplies the configuration implements the VintageNet.Technology behaviour.","ref":"VintageNet.Interface.html","title":"VintageNet.Interface","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.Interface.html#child_spec/1","title":"VintageNet.Interface.child_spec/1","type":"function"},{"doc":"Set a configuration on an interfaceConfigurations with invalid parameters raise exceptions. It's still possible that network configurations won't work even if they don't raise, but it should be due to something in the environment. For example, a network cable isn't plugged in or a WiFi access point is out of range.","ref":"VintageNet.Interface.html#configure/3","title":"VintageNet.Interface.configure/3","type":"function"},{"doc":"Deconfigure the interfaceThis doesn't exit this GenServer, but the interface won't be usable in any real way until it's configured again.This function is not normally called.","ref":"VintageNet.Interface.html#deconfigure/2","title":"VintageNet.Interface.deconfigure/2","type":"function"},{"doc":"Run an I/O command on the specified interface","ref":"VintageNet.Interface.html#ioctl/3","title":"VintageNet.Interface.ioctl/3","type":"function"},{"doc":"Start up an interfaceParameters:ifname - which interface","ref":"VintageNet.Interface.html#start_link/1","title":"VintageNet.Interface.start_link/1","type":"function"},{"doc":"Stop the interfaceNote that this doesn't deconfigure it.","ref":"VintageNet.Interface.html#stop/1","title":"VintageNet.Interface.stop/1","type":"function"},{"doc":"Convert a configuration to a raw oneThis can be used to validate a configuration without applying it.","ref":"VintageNet.Interface.html#to_raw_config/2","title":"VintageNet.Interface.to_raw_config/2","type":"function"},{"doc":"Wait for the interface to be configured","ref":"VintageNet.Interface.html#wait_until_configured/1","title":"VintageNet.Interface.wait_until_configured/1","type":"function"},{"doc":"Module for classifying and prioritizing network interfaces","ref":"VintageNet.Interface.Classification.html","title":"VintageNet.Interface.Classification","type":"module"},{"doc":"Compute the routing metric for an interface with a statusThis uses the prioritization list to figure out what number should be used for the Linux routing table metric. It could also be :disabled to indicate that a route shouldn't be added to the Linux routing tables at all.","ref":"VintageNet.Interface.Classification.html#compute_metric/4","title":"VintageNet.Interface.Classification.compute_metric/4","type":"function"},{"doc":"Return a reasonable default for prioritizing interfacesThe logic is that Internet-connected interfaces are prioritized first and after than Ethernet is preferred over WiFi and WiFi over LTE.","ref":"VintageNet.Interface.Classification.html#default_prioritization/0","title":"VintageNet.Interface.Classification.default_prioritization/0","type":"function"},{"doc":"Extract a number out of an interface nameThe result is the interface index for most interfaces seen on Nerves (eth0, eth1, ...), and something quite imperfect when using predictable interface naming (enp6s0, enp6s1).This is currently used to order priorities when there are two interfaces available of the same type that cannot be differentiated by other means. It has the one property of being easy to explain.","ref":"VintageNet.Interface.Classification.html#to_instance/1","title":"VintageNet.Interface.Classification.to_instance/1","type":"function"},{"doc":"Classify a network type based on its nameExamplesiex&gt; Classification.to_type(&quot;eth0&quot;) :ethernet iex&gt; Classification.to_type(&quot;wlp5s0&quot;) :wifi iex&gt; Classification.to_type(&quot;ppp0&quot;) :mobile","ref":"VintageNet.Interface.Classification.html#to_type/1","title":"VintageNet.Interface.Classification.to_type/1","type":"function"},{"doc":"Interface connection status:disconnected - The interface doesn't exist or it's not connected:lan - The interface is connected to the LAN, but may not be able reach the Internet:internet - Packets going through the interface should be able to reach the Internet","ref":"VintageNet.Interface.Classification.html#t:connection_status/0","title":"VintageNet.Interface.Classification.connection_status/0","type":"type"},{"doc":"Categorize interfaces based on their technology","ref":"VintageNet.Interface.Classification.html#t:interface_type/0","title":"VintageNet.Interface.Classification.interface_type/0","type":"type"},{"doc":"Prioritization for using default gatewaysExamples{:ethernet, :internet} - Wired ethernet that's Internet connected{:ethernet, :_} - Wired ethernet with any status{:_, :internet} - Any Internet-connected network interface","ref":"VintageNet.Interface.Classification.html#t:prioritization/0","title":"VintageNet.Interface.Classification.prioritization/0","type":"type"},{"doc":"A weight used to disambiguate interfaces that would otherwise have the same priorityLow weights are higher priority.","ref":"VintageNet.Interface.Classification.html#t:weight/0","title":"VintageNet.Interface.Classification.weight/0","type":"type"},{"doc":"The CommandRunner module runs commands specified in RawConfigsSee the RawConfig documentation for where lists of commands are specified. The following commands are supported:{:run, command, args} - Run a system command{:run_ignore_exit, command, args} - Same as :run, but without the exit status check{:fun, module, function_name, args} - Run a function by MFA{:fun, fun} - Run a function. Using the MFA form is preferred since it's easier to verfiy in unit tests.CommandRunner also implements RawConfig's file creation and cleanup logic.","ref":"VintageNet.Interface.CommandRunner.html","title":"VintageNet.Interface.CommandRunner","type":"module"},{"doc":"Create a list of files","ref":"VintageNet.Interface.CommandRunner.html#create_files/1","title":"VintageNet.Interface.CommandRunner.create_files/1","type":"function"},{"doc":"Remove a list of files","ref":"VintageNet.Interface.CommandRunner.html#remove_files/1","title":"VintageNet.Interface.CommandRunner.remove_files/1","type":"function"},{"doc":"Run one or more commandsSee the module docs for documentation on commands.","ref":"VintageNet.Interface.CommandRunner.html#run/1","title":"VintageNet.Interface.CommandRunner.run/1","type":"function"},{"doc":"Status of an EAP connection.Keysstatus Status of the connection.:started - the AP was assosiated and EAP is started.:success - the EAP connection was successful:failure - the EAP connection failed.method - EAP method used to authenticate. See the typespec for available values.timestamp - DateTime of the most recent EAP event.remote_certificate_verified? - if the cert was verified by the EAP server.","ref":"VintageNet.Interface.EAPStatus.html","title":"VintageNet.Interface.EAPStatus","type":"module"},{"doc":"Can be one of: as defined in eap_defs.h in the hostapd source. NONE IDENTITY NOTIFICATION NAK MD5 OTP GTC TLS LEAP SIM TTLS AKA PEAP MSCHAPV2 TLV TNC FAST PAX PSK SAKE IKEV2 AKA_PRIME GPSK PWD EKE TEAP EXPANDED","ref":"VintageNet.Interface.EAPStatus.html#t:method/0","title":"VintageNet.Interface.EAPStatus.method/0","type":"type"},{"doc":"","ref":"VintageNet.Interface.EAPStatus.html#t:t/0","title":"VintageNet.Interface.EAPStatus.t/0","type":"type"},{"doc":"This GenServer monitors a network interface for Internet connectivityInternet connectivity is determined by reachability to an IP address. If that address is reachable then other this updates a property to reflect that. Otherwise, the network interface is assumed to merely have LAN connectivity if it's up.","ref":"VintageNet.Interface.InternetConnectivityChecker.html","title":"VintageNet.Interface.InternetConnectivityChecker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.Interface.InternetConnectivityChecker.html#child_spec/1","title":"VintageNet.Interface.InternetConnectivityChecker.child_spec/1","type":"function"},{"doc":"Start the connectivity checker GenServer","ref":"VintageNet.Interface.InternetConnectivityChecker.html#start_link/1","title":"VintageNet.Interface.InternetConnectivityChecker.start_link/1","type":"function"},{"doc":"This module contains functions for testing whether the Internet is available.See the InternetConnectivityChecker for a GenServer that checks on regular intervals and updates VintageNet properties as needed.","ref":"VintageNet.Interface.InternetTester.html","title":"VintageNet.Interface.InternetTester","type":"module"},{"doc":"This &quot;ping&quot;'s a server on the Internet that has a good chance being availableThe &quot;ping&quot; is really a TCP connection attempt from the specified interface. Failures to connect don't necessarily mean that the Internet is down, but it's likely especially if the server that's specified in the configuration is highly available.Source IP-based routing is required for the TCP connect to go out the right network interface. This is configured by default when using VintageNet.","ref":"VintageNet.Interface.InternetTester.html#ping/1","title":"VintageNet.Interface.InternetTester.ping/1","type":"function"},{"doc":"","ref":"VintageNet.Interface.InternetTester.html#t:ping_error_reason/0","title":"VintageNet.Interface.InternetTester.ping_error_reason/0","type":"type"},{"doc":"This GenServer monitors a network interface for LAN connectivityCurrently LAN connectivity simply looks to see if it's possible to send a packet on the interface. It might or might not get to the desired destination on the LAN, but it won't obviously fail.This is an alternative to the InternetConnectivityChecker that actively monitors reachability to a host.","ref":"VintageNet.Interface.LANConnectivityChecker.html","title":"VintageNet.Interface.LANConnectivityChecker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.Interface.LANConnectivityChecker.html#child_spec/1","title":"VintageNet.Interface.LANConnectivityChecker.child_spec/1","type":"function"},{"doc":"Start the connectivity checker GenServer","ref":"VintageNet.Interface.LANConnectivityChecker.html#start_link/1","title":"VintageNet.Interface.LANConnectivityChecker.start_link/1","type":"function"},{"doc":"Raw configuration for an interfaceThis struct contains the low-level instructions for how to configure and deconfigure an interface.Fields::ifname - the name of the interface (e.g., &quot;eth0&quot;):type - the type of network interface (aka the module that created the config):source_config - the configuration that generated this one:required_ifnames - a list of ifnames that need to exist before starting this configuration. (e.g. [&quot;eth0&quot;]):retry_millis - if bringing the interface up fails, wait this amount of time before retrying:files - a list of file path, content tuples:restart_strategy - the restart strategy for the list of child_specs. I.e., :one_for_one | :one_for_all | :rest_for_one:child_specs - a set of child_specs for GenServers to start up and supervise:up_cmd_millis - the maximum amount of time to allow the up command list to take:up_cmds - a list of commands to run to configure the interface:down_cmd_millis - the maximum amount of time to allow the down command list to take:down_cmds - a list of commands to run to bring the interface down:cleanup_files - additional files to delete (the files listed in files are deleted too)","ref":"VintageNet.Interface.RawConfig.html","title":"VintageNet.Interface.RawConfig","type":"module"},{"doc":"","ref":"VintageNet.Interface.RawConfig.html#unimplemented_ioctl/2","title":"VintageNet.Interface.RawConfig.unimplemented_ioctl/2","type":"function"},{"doc":"A command to run for RawConfig.up_cmds or RawConfig.down_cmds","ref":"VintageNet.Interface.RawConfig.html#t:command/0","title":"VintageNet.Interface.RawConfig.command/0","type":"type"},{"doc":"","ref":"VintageNet.Interface.RawConfig.html#t:file_contents/0","title":"VintageNet.Interface.RawConfig.file_contents/0","type":"type"},{"doc":"","ref":"VintageNet.Interface.RawConfig.html#t:t/0","title":"VintageNet.Interface.RawConfig.t/0","type":"type"},{"doc":"Wrapper around the ip command for renaming interfaces","ref":"VintageNet.InterfaceRenamer.html","title":"VintageNet.InterfaceRenamer","type":"behaviour"},{"doc":"Renames an interface","ref":"VintageNet.InterfaceRenamer.html#rename/2","title":"VintageNet.InterfaceRenamer.rename/2","type":"function"},{"doc":"","ref":"VintageNet.InterfaceRenamer.html#c:rename_interface/2","title":"VintageNet.InterfaceRenamer.rename_interface/2","type":"callback"},{"doc":"","ref":"VintageNet.InterfaceRenamer.html#renamer/0","title":"VintageNet.InterfaceRenamer.renamer/0","type":"function"},{"doc":"Monitor available interfacesCurrently this works by polling the system for what interfaces are visible. They may or may not be configured.","ref":"VintageNet.InterfacesMonitor.html","title":"VintageNet.InterfacesMonitor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.InterfacesMonitor.html#child_spec/1","title":"VintageNet.InterfacesMonitor.child_spec/1","type":"function"},{"doc":"Force clear all addressesThis is useful to notify everyone that an address should not be used immediately. This can be used to fix a race condition where the blip for an address going away to coming back isn't reported.","ref":"VintageNet.InterfacesMonitor.html#force_clear_ipv4_addresses/1","title":"VintageNet.InterfacesMonitor.force_clear_ipv4_addresses/1","type":"function"},{"doc":"","ref":"VintageNet.InterfacesMonitor.html#start_link/1","title":"VintageNet.InterfacesMonitor.start_link/1","type":"function"},{"doc":"This module manages the contents of &quot;/etc/resolv.conf&quot;.This file is used by the C standard library and by Erlang for resolving domain names. Since both C programs and Erlang can do resolution, debugging problems in this area can be confusing due to varying behavior based on who's resolving at the time. See the /etc/erl_inetrc file on the target to review Erlang's configuration.This module assumes exclusive ownership on &quot;/etc/resolv.conf&quot;, so if any other code in the system tries to modify the file, their changes will be lost on the next update.It is expected that each network interface provides a configuration. This module will track configurations to network interfaces so that it can reflect which resolvers are around. Resolver order isn't handled.","ref":"VintageNet.NameResolver.html","title":"VintageNet.NameResolver","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.NameResolver.html#child_spec/1","title":"VintageNet.NameResolver.child_spec/1","type":"function"},{"doc":"Clear all entries in &quot;/etc/resolv.conf&quot; that are associated with the specified interface.","ref":"VintageNet.NameResolver.html#clear/1","title":"VintageNet.NameResolver.clear/1","type":"function"},{"doc":"Completely clear out &quot;/etc/resolv.conf&quot;.","ref":"VintageNet.NameResolver.html#clear_all/0","title":"VintageNet.NameResolver.clear_all/0","type":"function"},{"doc":"Set the search domain and name server list for the specified interface.This replaces any entries in the /etc/resolv.conf for this interface.","ref":"VintageNet.NameResolver.html#setup/3","title":"VintageNet.NameResolver.setup/3","type":"function"},{"doc":"Start the resolv.conf manager.","ref":"VintageNet.NameResolver.html#start_link/1","title":"VintageNet.NameResolver.start_link/1","type":"function"},{"doc":"Stop the resolv.conf manager.","ref":"VintageNet.NameResolver.html#stop/0","title":"VintageNet.NameResolver.stop/0","type":"function"},{"doc":"Customize the way VintageNet saves and loads configurations","ref":"VintageNet.Persistence.html","title":"VintageNet.Persistence","type":"behaviour"},{"doc":"","ref":"VintageNet.Persistence.html#call/2","title":"VintageNet.Persistence.call/2","type":"function"},{"doc":"Clear out a previously saved configuration","ref":"VintageNet.Persistence.html#c:clear/1","title":"VintageNet.Persistence.clear/1","type":"callback"},{"doc":"Enumerate the interfaces that have saved configurationsThis returns a list of interface names.","ref":"VintageNet.Persistence.html#c:enumerate/0","title":"VintageNet.Persistence.enumerate/0","type":"callback"},{"doc":"Load the configuration of an interface","ref":"VintageNet.Persistence.html#c:load/1","title":"VintageNet.Persistence.load/1","type":"callback"},{"doc":"Save the configuration for the specified interface","ref":"VintageNet.Persistence.html#c:save/2","title":"VintageNet.Persistence.save/2","type":"callback"},{"doc":"Save and load configurations from flat files","ref":"VintageNet.Persistence.FlatFile.html","title":"VintageNet.Persistence.FlatFile","type":"module"},{"doc":"Don't save or load configuration at all.","ref":"VintageNet.Persistence.Null.html","title":"VintageNet.Persistence.Null","type":"module"},{"doc":"This is a behaviour for implementing platform-specific power management.From VintageNet's point of view, network devices have the following lifecycle:off ---&gt; on ---&gt; powering-off ---&gt; offPower management does not necessarily mean controlling the power. The end effect should be similar, since VintageNet will try to toggle the power off and on if the network interface doesn't seem to be working. For example, unloading the kernel module for the network device on &quot;power off&quot; and loading it on &quot;power on&quot; may have the desired effect of getting a network interface unstuck.When a device is &quot;on&quot;, VintageNet expects to be regularly told that the device is working ok. Working ok is device dependent, but could be something like the device has transmitted and received data. If VintageNet is not told that the device is working for a long enough time, it will reset the device by powering it off and then back on again.VintageNet calls functions here based on how it wants to transition a device. VintageNet maintains the device's power status internally, so implementations can blindly do what VintageNet tells them too in most cases. Powering on and off can be asynchronous to these function calls. VintageNet uses the presence of the networking interface (like &quot;wlan0&quot;) to determine when the device is really available for networking.The following timeouts are important to consider:time_to_power_offpower_on_hold_timemin_power_off_timewatchdog_timeoutThe time_to_power_off specifies the time in the powering-off state. This is the maximum time to allow for a graceful shutdown. VintageNet won't bother the device until that time has expired. That means that if there's a request to use the device, it will wait the powering-off time before calling finish_power_off and then it will power the device back on. Device app notes may have recommendations for this time.The power_on_hold_time specifies how much time a device should be in the powered-on state before it is ok to power off again. This allows devices some time to initialize and recover on their own.The min_power_off_time specifies how long the device should remain powered off before it is powered back on.Finally, watchdog_timeout specifies how long to wait between notifications that the device is ok. Code reports that a device is ok by calling VintageNet.PowerManager.PMControl.pet_watchdog/1.While normal Erlang supervision expects that it can restart processes immediately and without regard to how long they have been running, bad things can happen to hardware if too aggressively restarted. Devices also initialize asynchronously so it's hard to know when they're fully available and some flakiness may be naturally due to VintageNet not knowing how to wait for a component to finish initialization. Please review your network device's power management guidelines before too aggressively reducing hold times. Cellular devices, in particular, want to signal their disconnection from the network to the tower and flush any unsaved configuration changes to Flash before power removal.Here's an example for a cellular device with a reset line connected to it:power_on - De-assert the reset line. Return a power_on_hold_time of 10 minutesstart_powering_off - Open the UART and send the power down command to the modem. Return a time_to_power_off of 1 minute.power_off - Assert the reset line and return that power shouldn't be turned back on for another 10 seconds.PowerManager implementation lifetimes are the same as VintageNet's. In other words, they start and end with VintageNet. This is unlike a network interface which runs only as its existence and configuration allow. As such, VintageNet needs to know about all PowerManager implementations in its application environment. For example, add something like this to your config.exs:config :vintage_net, power_managers: [{MyCellularPM, [ifname: &quot;ppp0&quot;, watchdog_timeout: 60_000, reset_gpio: 123]}]Each tuple is the implementation's module name and init arguments. VintageNet requires :ifname to be set. If you're managing the power for an interface with a dynamic name, enable predictable interface naming with VintageNet and use that name. The watchdog_timeout parameter is optional and defaults to one minute.","ref":"VintageNet.PowerManager.html","title":"VintageNet.PowerManager","type":"behaviour"},{"doc":"Handle other messagesAll unknown messages sent to the power management GenServer come here. This callback is similar to GenServer.handle_info/2.To receive your own messages here, send them to self() in code run in any of the other callbacks. Another option is to call VintageNet.PowerManager.PMControl.send_message/2","ref":"VintageNet.PowerManager.html#c:handle_info/2","title":"VintageNet.PowerManager.handle_info/2","type":"callback"},{"doc":"Initialize state for managing the power to the specified interfaceThis is called on start and if the power management GenServer restarts. It should not assume that hardware is powered down.IMPORTANT: VintageNet assumes that init/1 runs quickly and succeeds. Errors and exceptions from calling init/1 are handled by disabling the PowerManager. The reason is that VintageNet has no knowledge on how to recover and disabling a power manager was deemed less bad that having supervision tree failures propagate upwards to terminate VintageNet. Messages are logged if this does happen.","ref":"VintageNet.PowerManager.html#c:init/1","title":"VintageNet.PowerManager.init/1","type":"callback"},{"doc":"Power off the hardwareThis function should finish powering off the network interface hardware. Since this is called after the graceful power down should have completed, it should forcefully turn off the power to the hardware.The implementation also returns a time that power must remain off. power_on/1 won't be called until that time expires.","ref":"VintageNet.PowerManager.html#c:power_off/1","title":"VintageNet.PowerManager.power_off/1","type":"callback"},{"doc":"Power on the hardware for a network interfaceThe function should turn on power rails, deassert reset lines, load kernel modules or do whatever else is necessary to make the interface show up in Linux.Failure handling is not supported by VintageNet yet, so if power up can fail and the right handling for that is to try again later, then this function should do that.It is ok for this function to return immediately. When the network interface appears, VintageNet will start trying to use it.The return tuple should include the number of seconds VintageNet should wait before trying to power down the module again. This value should be sufficiently large to avoid getting into loops where VintageNet gives up on a network interface before it has initialized. 10 minutes (600 seconds), for example, is a reasonable setting.","ref":"VintageNet.PowerManager.html#c:power_on/1","title":"VintageNet.PowerManager.power_on/1","type":"callback"},{"doc":"Start powering off the hardware for a network interfaceThis function should start a graceful shutdown of the network interface hardware. It may return immediately. The return value specifies how long in seconds VintageNet should wait before calling power_off/2. The idea is that a graceful power off should be allowed some time to complete, but not forever.","ref":"VintageNet.PowerManager.html#c:start_powering_off/1","title":"VintageNet.PowerManager.start_powering_off/1","type":"callback"},{"doc":"Power management control GenServerThis GenServer runs a PowerManager implementation for a network device. It provides the API for powering on and off a device and for signally that it's working well.Internally, it runs a state machine that translates power on and off requests into actions sent to the PowerManager implementation. The state machine handles the timing of actions so that hardware gets a chance to initialize and isn't reset to quickly. PowerManager implementations specify times.Since networking devices can sometimes hang or fail in unexpected ways, this module can power them off and on to try to get them back in a good state. This is implemented in terms of a watchdog. Code that can detect the network device being in a good state should call pet_watchdog/1. For example, code that checks internet connectivity could call pet_watchdog/1 since that's a pretty good sign that the device works. Other checks are possible. If pet_watchdog/1 isn't called, this module will restart the network device.","ref":"VintageNet.PowerManager.PMControl.html","title":"VintageNet.PowerManager.PMControl","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.PowerManager.PMControl.html#child_spec/1","title":"VintageNet.PowerManager.PMControl.child_spec/1","type":"function"},{"doc":"Force resetThis is intended to be called based on human interaction. For example, by a UI button or by a developer who knows or strongly suspects that something is wrong with the network device it needs a reboot.Resetting devices that have been powered off will NOT power them on.Calling this automatically is not recommended especially if it is used as an alternative to the watchdog mechanism. The reason is that it is easier to identify where the device is working than it is to identify every way it can fail. Also, force reset ignores minimum on times since assumption is that if someone wants to reset, they're ready to reset now.","ref":"VintageNet.PowerManager.PMControl.html#force_reset/1","title":"VintageNet.PowerManager.PMControl.force_reset/1","type":"function"},{"doc":"Return information about the specified power managerNOTE: the map returned may change in the future","ref":"VintageNet.PowerManager.PMControl.html#info/1","title":"VintageNet.PowerManager.PMControl.info/1","type":"function"},{"doc":"Pet watchdogCall this whenever the network connection is in a good state. If it has not been called by the watchdog timeout, the device will be rebooted.","ref":"VintageNet.PowerManager.PMControl.html#pet_watchdog/1","title":"VintageNet.PowerManager.PMControl.pet_watchdog/1","type":"function"},{"doc":"Power offThis is called when VintageNet stops using an interface. The current state in the power management state machine determines how this is handled. For example, the power could already be off.","ref":"VintageNet.PowerManager.PMControl.html#power_off/1","title":"VintageNet.PowerManager.PMControl.power_off/1","type":"function"},{"doc":"Power onThis should be called whenever an interface should be powered on. It can be called more than once. If you want the network interface to be on, it is always safe to call this. An internal state machine will ignore redundant calls.","ref":"VintageNet.PowerManager.PMControl.html#power_on/1","title":"VintageNet.PowerManager.PMControl.power_on/1","type":"function"},{"doc":"","ref":"VintageNet.PowerManager.PMControl.html#safe_init/1","title":"VintageNet.PowerManager.PMControl.safe_init/1","type":"function"},{"doc":"Send an arbitrary message to the power manager for an interfaceThis will be received by the PowerManager's handle_info/2 callback.","ref":"VintageNet.PowerManager.PMControl.html#send_message/2","title":"VintageNet.PowerManager.PMControl.send_message/2","type":"function"},{"doc":"Start up a serverThis is intended to be called via VintageNet.PowerManager.SupervisorArguments::impl - the module that implements PowerManager:impl_args - arguments to pass to the PowerManager's init/1 call","ref":"VintageNet.PowerManager.PMControl.html#start_link/1","title":"VintageNet.PowerManager.PMControl.start_link/1","type":"function"},{"doc":"Handles predictable interface names by subscribing to the property table and renaming matching interface names based on the configuration in application environment.","ref":"VintageNet.PredictableInterfaceName.html","title":"VintageNet.PredictableInterfaceName","type":"module"},{"doc":"Return whether an ifname is a built-in oneBuilt-in names start with eth, wlan, etc. and cannot be used as interfaces names when using the predictable networking feature.Examples:iex&gt; PredictableInterfaceName.built_in?(&quot;wlan0&quot;) true iex&gt; PredictableInterfaceName.built_in?(&quot;eth50&quot;) true iex&gt; PredictableInterfaceName.built_in?(&quot;lan&quot;) false","ref":"VintageNet.PredictableInterfaceName.html#built_in?/1","title":"VintageNet.PredictableInterfaceName.built_in?/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.PredictableInterfaceName.html#child_spec/1","title":"VintageNet.PredictableInterfaceName.child_spec/1","type":"function"},{"doc":"Called before interface configuration.First checks if vintage_net is configured to use predictable interface names, if so checks the given ifname for &quot;common&quot; naming schemes.Instead of a boolean this function returns :ok on success, and {:error, not_predictable_interface_name} on failure. This is done to allow usage in with chains.","ref":"VintageNet.PredictableInterfaceName.html#precheck/1","title":"VintageNet.PredictableInterfaceName.precheck/1","type":"function"},{"doc":"","ref":"VintageNet.PredictableInterfaceName.html#start_link/1","title":"VintageNet.PredictableInterfaceName.start_link/1","type":"function"},{"doc":"hw_path to a user supplied ifname mapping","ref":"VintageNet.PredictableInterfaceName.html#t:hw_path_config/0","title":"VintageNet.PredictableInterfaceName.hw_path_config/0","type":"type"},{"doc":"PropertyTables are in-memory key-value storesUsers can subscribe to keys or groups of keys to be notified of changes.Keys are hierarchically layed out with each key being represented as a list for the path to the key. For example, to get the current state of the network interface eth0, you would get the value of the key, [&quot;net&quot;, &quot;ethernet&quot;, &quot;eth0&quot;].Values can be any Elixir data structure except for nil. nil is used to identify non-existent keys. Therefore, setting a property to nil deletes the property.Users can get and listen for changes in multiple keys by specifying prefix paths. For example, if you wants to get every network property, run:PropertyTable.get_by_prefix(table, [&quot;net&quot;])Likewise, you can subscribe to changes in the network status by running:PropertyTable.subscribe(table, [&quot;net&quot;])Properties can include metadata. PropertyTable only specifies that metadata is a map.","ref":"VintageNet.PropertyTable.html","title":"VintageNet.PropertyTable","type":"module"},{"doc":"Returns a specification to start a property_table under a supervisor. See Supervisor.","ref":"VintageNet.PropertyTable.html#child_spec/1","title":"VintageNet.PropertyTable.child_spec/1","type":"function"},{"doc":"Clear out a property","ref":"VintageNet.PropertyTable.html#clear/2","title":"VintageNet.PropertyTable.clear/2","type":"function"},{"doc":"Clear out all properties under a prefix","ref":"VintageNet.PropertyTable.html#clear_prefix/2","title":"VintageNet.PropertyTable.clear_prefix/2","type":"function"},{"doc":"Fetch a property with the time that it was setTimestamps come from System.monotonic_time()","ref":"VintageNet.PropertyTable.html#fetch_with_timestamp/2","title":"VintageNet.PropertyTable.fetch_with_timestamp/2","type":"function"},{"doc":"Get the current value of a property","ref":"VintageNet.PropertyTable.html#get/3","title":"VintageNet.PropertyTable.get/3","type":"function"},{"doc":"Get a list of all properties matching the specified prefix","ref":"VintageNet.PropertyTable.html#get_by_prefix/2","title":"VintageNet.PropertyTable.get_by_prefix/2","type":"function"},{"doc":"Get a list of all properties matching the specified prefix","ref":"VintageNet.PropertyTable.html#match/2","title":"VintageNet.PropertyTable.match/2","type":"function"},{"doc":"Update a property and notify listeners","ref":"VintageNet.PropertyTable.html#put/4","title":"VintageNet.PropertyTable.put/4","type":"function"},{"doc":"","ref":"VintageNet.PropertyTable.html#start_link/1","title":"VintageNet.PropertyTable.start_link/1","type":"function"},{"doc":"Subscribe to receive events","ref":"VintageNet.PropertyTable.html#subscribe/2","title":"VintageNet.PropertyTable.subscribe/2","type":"function"},{"doc":"Stop subscribing to a property","ref":"VintageNet.PropertyTable.html#unsubscribe/2","title":"VintageNet.PropertyTable.unsubscribe/2","type":"function"},{"doc":"","ref":"VintageNet.PropertyTable.html#t:metadata/0","title":"VintageNet.PropertyTable.metadata/0","type":"type"},{"doc":"","ref":"VintageNet.PropertyTable.html#t:options/0","title":"VintageNet.PropertyTable.options/0","type":"type"},{"doc":"Properties","ref":"VintageNet.PropertyTable.html#t:property/0","title":"VintageNet.PropertyTable.property/0","type":"type"},{"doc":"","ref":"VintageNet.PropertyTable.html#t:property_value/0","title":"VintageNet.PropertyTable.property_value/0","type":"type"},{"doc":"","ref":"VintageNet.PropertyTable.html#t:property_with_wildcards/0","title":"VintageNet.PropertyTable.property_with_wildcards/0","type":"type"},{"doc":"A table_id identifies a group of properties","ref":"VintageNet.PropertyTable.html#t:table_id/0","title":"VintageNet.PropertyTable.table_id/0","type":"type"},{"doc":"","ref":"VintageNet.PropertyTable.html#t:value/0","title":"VintageNet.PropertyTable.value/0","type":"type"},{"doc":"This module computes the desired routing table contentsIt's used by the RouteManager to update the Linux routing tables when interfaces come online or change state. See the RouteManager docs for a discussion of how routes are configured.The functions in this module have no side effects so that it's easier to test that routing scenarios result in correct Linux routing table configurations.","ref":"VintageNet.Route.Calculator.html","title":"VintageNet.Route.Calculator","type":"module"},{"doc":"Compute a Linux routing table configurationThe entries are ordered so that List.myers_difference/2 can be used to minimize the routing table changes.","ref":"VintageNet.Route.Calculator.html#compute/3","title":"VintageNet.Route.Calculator.compute/3","type":"function"},{"doc":"Initialize state carried between calculations","ref":"VintageNet.Route.Calculator.html#init/0","title":"VintageNet.Route.Calculator.init/0","type":"function"},{"doc":"Return the table indices used for routing based on source IP.","ref":"VintageNet.Route.Calculator.html#rule_table_index_range/0","title":"VintageNet.Route.Calculator.rule_table_index_range/0","type":"function"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:default_route/0","title":"VintageNet.Route.Calculator.default_route/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:entries/0","title":"VintageNet.Route.Calculator.entries/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:entry/0","title":"VintageNet.Route.Calculator.entry/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:interface_infos/0","title":"VintageNet.Route.Calculator.interface_infos/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:local_route/0","title":"VintageNet.Route.Calculator.local_route/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:metric/0","title":"VintageNet.Route.Calculator.metric/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:rule/0","title":"VintageNet.Route.Calculator.rule/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:table_index/0","title":"VintageNet.Route.Calculator.table_index/0","type":"type"},{"doc":"","ref":"VintageNet.Route.Calculator.html#t:table_indices/0","title":"VintageNet.Route.Calculator.table_indices/0","type":"type"},{"doc":"This module knows how to invoke the ip command to modify the Linux routing tables","ref":"VintageNet.Route.IPRoute.html","title":"VintageNet.Route.IPRoute","type":"module"},{"doc":"Add a default route","ref":"VintageNet.Route.IPRoute.html#add_default_route/4","title":"VintageNet.Route.IPRoute.add_default_route/4","type":"function"},{"doc":"Add a local route","ref":"VintageNet.Route.IPRoute.html#add_local_route/5","title":"VintageNet.Route.IPRoute.add_local_route/5","type":"function"},{"doc":"Add a source IP address -&gt; routing table rule","ref":"VintageNet.Route.IPRoute.html#add_rule/2","title":"VintageNet.Route.IPRoute.add_rule/2","type":"function"},{"doc":"Clear one local route generically","ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/1","title":"VintageNet.Route.IPRoute.clear_a_local_route/1","type":"function"},{"doc":"Clear one local route","ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/5","title":"VintageNet.Route.IPRoute.clear_a_local_route/5","type":"function"},{"doc":"Clear one default route out of the main table for any interface","ref":"VintageNet.Route.IPRoute.html#clear_a_route/0","title":"VintageNet.Route.IPRoute.clear_a_route/0","type":"function"},{"doc":"Clear one default route that goes to the specified interface","ref":"VintageNet.Route.IPRoute.html#clear_a_route/2","title":"VintageNet.Route.IPRoute.clear_a_route/2","type":"function"},{"doc":"Clear out one rule","ref":"VintageNet.Route.IPRoute.html#clear_a_rule/1","title":"VintageNet.Route.IPRoute.clear_a_rule/1","type":"function"},{"doc":"Clear all routes on all interfaces","ref":"VintageNet.Route.IPRoute.html#clear_all_routes/0","title":"VintageNet.Route.IPRoute.clear_all_routes/0","type":"function"},{"doc":"Clear all rules that select the specified table or tables","ref":"VintageNet.Route.IPRoute.html#clear_all_rules/1","title":"VintageNet.Route.IPRoute.clear_all_rules/1","type":"function"},{"doc":"This module contains helpers for updating the global routing properties.These include:[&quot;available_interfaces&quot;][&quot;connection&quot;]","ref":"VintageNet.Route.Properties.html","title":"VintageNet.Route.Properties","type":"module"},{"doc":"Update the available_interfaces property based on the low level routesThis function orders interfaces based on metric just like Linux does","ref":"VintageNet.Route.Properties.html#update_available_interfaces/1","title":"VintageNet.Route.Properties.update_available_interfaces/1","type":"function"},{"doc":"Update the overall connection status:disconnected &lt; :lan &lt; :internet","ref":"VintageNet.Route.Properties.html#update_best_connection/1","title":"VintageNet.Route.Properties.update_best_connection/1","type":"function"},{"doc":"This module manages the default route.Devices with more than one network interface may have more than one way of reaching the Internet. The routing table decides which interface an IP packet should use by looking at the &quot;default route&quot; entries. One interface is chosen.Since not all interfaces are equal, we'd like Linux to pick the fastest and lowest latency one. for example, one could prefer wired Ethernet over WiFi and prefer WiFi over a cellular connection. This module lets you specify an ordering for interfaces and sets up the routes based on this ordering.This module also handles networking failures. One failure that Linux can't figure out on its own is whether an interface can reach the Internet. Internet reachability is handled elsewhere like in the ConnectivityChecker module. This module should be told reachability status so that it can properly order default routes so that the best reachable interface is used.IMPORTANT: This module uses priority-based routing. Make sure the following kernel options are enabled:CONFIG_IP_ADVANCED_ROUTER=y CONFIG_IP_MULTIPLE_TABLES=y","ref":"VintageNet.RouteManager.html","title":"VintageNet.RouteManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.RouteManager.html#child_spec/1","title":"VintageNet.RouteManager.child_spec/1","type":"function"},{"doc":"Clear out the default gateway for an interface.","ref":"VintageNet.RouteManager.html#clear_route/1","title":"VintageNet.RouteManager.clear_route/1","type":"function"},{"doc":"Set the connection status on an interface.Changing the connection status can re-prioritize routing. The specified interface doesn't need to have a default route.","ref":"VintageNet.RouteManager.html#set_connection_status/2","title":"VintageNet.RouteManager.set_connection_status/2","type":"function"},{"doc":"Set the order that default gateways should be usedThe list is ordered from highest priority to lowest","ref":"VintageNet.RouteManager.html#set_prioritization/1","title":"VintageNet.RouteManager.set_prioritization/1","type":"function"},{"doc":"Set the default route for an interface.This replaces any existing routes on that interface","ref":"VintageNet.RouteManager.html#set_route/4","title":"VintageNet.RouteManager.set_route/4","type":"function"},{"doc":"Start the route manager.","ref":"VintageNet.RouteManager.html#start_link/1","title":"VintageNet.RouteManager.start_link/1","type":"function"},{"doc":"Stop the route manager.","ref":"VintageNet.RouteManager.html#stop/0","title":"VintageNet.RouteManager.stop/0","type":"function"},{"doc":"Technologies define how network interface types workVintageNet comes with several built-in technologies, but more can be added or existing ones modified by implementing the Technology behaviour.","ref":"VintageNet.Technology.html","title":"VintageNet.Technology","type":"behaviour"},{"doc":"Check that the system has all of the required programs for this technologyThis is intended to help identify missing programs without configuring a network.","ref":"VintageNet.Technology.html#c:check_system/1","title":"VintageNet.Technology.check_system/1","type":"callback"},{"doc":"Handle an ioctl that has been requested on the network interfaceThe function runs isolated in its own process and only one ioctl is guaranteed to be running at a time. VintageNet will handle crashes and hangs and unceremoniously kill the ioctl if the user changes their mind and reconfigures the network interface.Ioctl support is optional. Examples of ioctls include::scan - scan for WiFi networks:statistics - return a map of network statistics","ref":"VintageNet.Technology.html#c:ioctl/3","title":"VintageNet.Technology.ioctl/3","type":"callback"},{"doc":"Normalize a configurationTechnologies use this to update input configurations to a canonical representation. This includes things like inserting default fields, converting IP addresses passed in as strings to tuples, and deriving parameters so that they need not be derived again in the future.Configuration errors raise exceptions.","ref":"VintageNet.Technology.html#c:normalize/1","title":"VintageNet.Technology.normalize/1","type":"callback"},{"doc":"Convert a technology-specific configuration to one for VintageNetThe config is the normalized configuration map (normalize/1 will have been called at some point so the technology does not need to call it again).The opts parameter contains VintageNet's application environment. This contains potentially useful file paths and other information.Configuration errors raise exceptions. Errors should be infrequent, though, since VintageNet will call normalize/1 first and expects most errors to be caught by it.","ref":"VintageNet.Technology.html#c:to_raw_config/3","title":"VintageNet.Technology.to_raw_config/3","type":"callback"},{"doc":"An interface with this technology is unconfigured","ref":"VintageNet.Technology.Null.html","title":"VintageNet.Technology.Null","type":"module"},{"doc":"This GenServer routes messages from C and shell scripts to the appropriate places in VintageNet.","ref":"VintageNet.ToElixir.Server.html","title":"VintageNet.ToElixir.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"VintageNet.ToElixir.Server.html#child_spec/1","title":"VintageNet.ToElixir.Server.child_spec/1","type":"function"},{"doc":"Start the GenServer.","ref":"VintageNet.ToElixir.Server.html#start_link/1","title":"VintageNet.ToElixir.Server.start_link/1","type":"function"},{"doc":"A behaviour for handling notifications from udhcpcExampledefmodule MyApp.UdhcpcHandler do @behaviour VintageNet.ToElixir.UdhcpcHandler @impl VintageNet.ToElixir.UdhcpcHandler def deconfig(ifname, data) do ... end endTo have VintageNet invoke it, add the following to your config.exs:config :vintage_net, udhcpc_handler: MyApp.UdhcpcHandler","ref":"VintageNet.ToElixir.UdhcpcHandler.html","title":"VintageNet.ToElixir.UdhcpcHandler","type":"behaviour"},{"doc":"Handle an assignment from the DHCP server","ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:bound/2","title":"VintageNet.ToElixir.UdhcpcHandler.bound/2","type":"callback"},{"doc":"Deconfigure the specified interface","ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:deconfig/2","title":"VintageNet.ToElixir.UdhcpcHandler.deconfig/2","type":"callback"},{"doc":"Called internally by vintage_net to dispatch calls","ref":"VintageNet.ToElixir.UdhcpcHandler.html#dispatch/3","title":"VintageNet.ToElixir.UdhcpcHandler.dispatch/3","type":"function"},{"doc":"Handle a failure to get a lease","ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:leasefail/2","title":"VintageNet.ToElixir.UdhcpcHandler.leasefail/2","type":"callback"},{"doc":"Handle a DHCP NAK","ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:nak/2","title":"VintageNet.ToElixir.UdhcpcHandler.nak/2","type":"callback"},{"doc":"Handle the renewal of a DHCP lease","ref":"VintageNet.ToElixir.UdhcpcHandler.html#c:renew/2","title":"VintageNet.ToElixir.UdhcpcHandler.renew/2","type":"callback"},{"doc":"","ref":"VintageNet.ToElixir.UdhcpcHandler.html#t:update_data/0","title":"VintageNet.ToElixir.UdhcpcHandler.update_data/0","type":"type"},{"doc":"A behaviour for handling notifications from udhcpdExampledefmodule MyApp.UdhcpdHandler do @behaviour VintageNet.ToElixir.UdhcpdHandler @impl VintageNet.ToElixir.UdhcpdHandler def lease_update(ifname, report_data) do ... end endTo have VintageNet invoke it, add the following to your config.exs:config :vintage_net, udhcpd_handler: MyApp.UdhcpdHandler","ref":"VintageNet.ToElixir.UdhcpdHandler.html","title":"VintageNet.ToElixir.UdhcpdHandler","type":"behaviour"},{"doc":"Called internally by vintage_net to dispatch calls","ref":"VintageNet.ToElixir.UdhcpdHandler.html#dispatch/3","title":"VintageNet.ToElixir.UdhcpdHandler.dispatch/3","type":"function"},{"doc":"The DHCP lease file was updated","ref":"VintageNet.ToElixir.UdhcpdHandler.html#c:lease_update/2","title":"VintageNet.ToElixir.UdhcpdHandler.lease_update/2","type":"callback"},{"doc":"","ref":"VintageNet.ToElixir.UdhcpdHandler.html#t:update_data/0","title":"VintageNet.ToElixir.UdhcpdHandler.update_data/0","type":"type"},{"doc":"NOTE: If you've been using vintage_net v0.6.x or earlier, we split out network technology support out to separate libraries in v0.7.0. You'll need to add those libraries to your mix dependency list and rename some atoms. Configurations stored on deployed devices will be automatically updated. See the v0.7.0 release notes for details.VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features:Ethernet and WiFi support included. Extendible to other technologiesDefault configurations specified in your Application configRuntime updates to configurations are persisted and applied on next boot (configurations are obfuscated by default to hide WiFi passphrases)Simple subscription to network status change eventsConnect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular)Internet connection monitoring and failure detectionPredictable network interface namesTL;DR: Don't care about any of this and just want the string to copy/paste to set up networking? See the VintageNet Cookbook.The following network configurations are supported:[x] Wired Ethernet, IPv4 DHCP[x] Wired Ethernet, IPv4 static IP[x] WiFi password-less and WEP[x] WPA2 PSK and EAP[x] USB gadget mode Ethernet, IPv4 DHCP server to supply host IP address[x] Cellular networks (see vintage_net_mobile for details)[x] WiFi AP mode[ ] IPv6 - Partially supported. SLAAC configuration works.vintage_net takes a different approach to networking from nerves_network. Its focus is on building and applying network configurations. Where nerves_network provided configurable state machines, vintage_net turns human-readable configurations into everything from configuration files and calls to ip to starting up networking GenServers and routing table updates. This makes it easier to add support for new network technologies and features. While Elixir and Erlang were great to implement network protocols in, it was frequently more practical to reuse embedded Linux implementations. Importantly, though, vintage_net monitors Linux daemons under its OTP supervision tree so failures on both the &quot;C&quot; and Elixir sides propagate in the expected ways.Another important difference is that VintageNet doesn't attempt to make incremental modifications to configurations. It completely tears down an interface's connection and then brings up new configurations in a fresh state. Network reconfiguration is assumed to be an infrequent event so while this can cause a hiccup in the network connectivity, it removes state machine code that made nerves_network hard to maintain.","ref":"readme.html","title":"README","type":"extras"},{"doc":"First, if you're modifying an existing project, you will need to remove nerves_network and nerves_init_gadget. vintage_net doesn't work with either of them. You'll get an error if any project references those packages.There are two routes to integrating vintage_net:Use nerves_pack. nerves_pack is like nerves_init_gadget, but for vintage_net.Copy and paste from vintage_net_exampleThe next step is to make sure that your Nerves system is compatible. The official Nerves systems released after 12/11/2019 work without modification. If rolling your own Nerves port, you will need the following Linux kernel options enabled:CONFIG_IP_ADVANCED_ROUTER=yCONFIG_IP_MULTIPLE_TABLES=yThen make sure that you have the following Busybox options enabled:CONFIG_IFCONFIG=y - ifconfig ifconfigCONFIG_UDHCPC=y - udhcpc DHCP ClientCONFIG_UDHCPD=y - udhcpd DHCP Server (optional)Finally, you'll need to choose what network connection technologies that you want available in your firmware. If using nerves_pack, you'll get support for wired Ethernet, WiFi, and USB gadget networking automatically. Otherwise, add one or more of the following to your dependency list:vintage_net_ethernet - Standard wired Ethernetvintage_net_wifi - Client configurations for 802.11 WiFivintage_net_direct - Direct connections like those used for USB gadgetvintage_net_mobile - Support for a few cellular modems","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"VintageNet has many application configuration keys. Most defaults are fine. At a minimum, you'll want to specify a default configuration and default regulatory domain if using WiFi. In your main config.exs, add the following:config :vintage_net, regulatory_domain: &quot;US&quot;, config: [ {&quot;eth0&quot;, %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}}, {&quot;wlan0&quot;, %{type: VintageNetWiFi}} ]This sets the regulatory domain to the US (set to your ISO 3166-1 alpha-2 country code. This code is passed on to the drivers for WiFi and other wireless networking technologies so that they comply with local regulations. If you need a global default, set to &quot;00&quot; or don't set at all. Unfortunately, this may mean that an access point isn't visible if it is running on a frequency that's allowed in your country, but not globally.The config section is a list of network configurations. The one shown above configures DHCP on wired Ethernet and minimally starts up a WiFi LAN so that it's possible to scan for networks. The typical setup is to provide generic defaults here. Static IP addresses, WiFi SSIDs and credentials are more appropriately configured at run-time. VintageNet persists configurations too. Details on network configuration are described later.The following table describes the other application config keys.KeyDescriptionconfigA list of default network configurationstmpdirPath to a temporary directory for VintageNetto_elixir_socketName to use for the Unix domain socket for C to Elixir communicationudhcpc_handlerModule for handling notifications from udhcpcresolvconfPath to /etc/resolv.confpersistenceModule for persisting network configurationspersistence_dirPath to a directory for storing persisted configurationspersistence_secretA 16-byte secret or an MFA for getting a secretinternet_hostIP address for host to ping to check for Internet connectivity. Must be a tuple of integers ({1, 1, 1, 1}) or binary representation (&quot;1.1.1.1&quot;)regulatory_domainISO 3166-1 alpha-2 country (00 for global, US, etc.)","ref":"readme.html#configuration","title":"README - Configuration","type":"extras"},{"doc":"VintageNet supports several network technologies out of the box and third-party libraries can provide more via the VintageNet.Technology behaviour.Configurations are Elixir maps. These are specified in three places:The vintage_net application config (e.g., your config.exs)Locally saved configuration (see the VintageNet.Persistence behaviour for replacing the default)Calling VintageNet.configure/2 to change the configuration at run-timeWhen vintage_net starts, it applies saved configurations first and if any thing is wrong with those configs, it reverts to the application config. A good practice is to have safe defaults for all network interfaces in the application config.The only required key in the configuration maps is :type. All other keys follow from the type. :type should be set to a module that implements the VintageNet.Technology behaviour. The following are common technologies:VintageNetEthernet - Standard wired EthernetVintageNetWiFi - Client configurations for 802.11 WiFiVintageNetDirect - Direct connections like those used for USB gadget connectionsVintageNet.Technology.Null - An empty configuration useful for turning off a configurationSee the links above for specific documentation.","ref":"readme.html#network-interface-configuration","title":"README - Network interface configuration","type":"extras"},{"doc":"By default, VintageNet stores network configuration to disk. If you are migrating from nerves_network you may already have a persistence implementation. To disable the default persistence, configure vintage_net as follows:config :vintage_net, persistence: VintageNet.Persistence.Null","ref":"readme.html#persistence","title":"README - Persistence","type":"extras"},{"doc":"Debugging networking issues is not fun. When you're starting out with vintage_net, it is highly recommended to connect to your target using a method that doesn't require networking to work. This could be a UART connection to an IEx console on a Nerves device or maybe just hooking up a keyboard and monitor.If having trouble, first check VintageNet.info() to verify the configuration and connection status:iex&gt; VintageNet.info VintageNet 0.3.0 All interfaces: [&quot;eth0&quot;, &quot;lo&quot;, &quot;tap0&quot;, &quot;wlan0&quot;] Available interfaces: [&quot;eth0&quot;, &quot;wlan0&quot;] Interface eth0 Type: VintageNetEthernet Present: true State: :configured Connection: :internet Configuration: %{ipv4: %{method: :dhcp}, type: VintageNetEthernet} Interface wlan0 Type: VintageNetWiFi Present: true State: :configured Connection: :internet Configuration: %{ ipv4: %{method: :dhcp}, type: VintageNetWiFi, wifi: %{ key_mgmt: :wpa_psk, mode: :infrastructure, psk: &quot;******&quot;, ssid: &quot;MyLAN&quot; } }If you're using Toolshed, try running the following:iex&gt; ifconfig lo: flags=[:up, :loopback, :running] inet 127.0.0.1 netmask 255.0.0.0 inet ::1 netmask ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff hwaddr 00:00:00:00:00:00 eth0: flags=[:up, :broadcast, :running, :multicast] inet 192.168.9.131 netmask 255.255.255.0 broadcast 192.168.9.255 inet fe80::6264:5ff:fee1:4045 netmask ffff:ffff:ffff:ffff:: hwaddr 60:64:05:e1:40:45 wlan0: flags=[:up, :broadcast, :running, :multicast] inet 192.168.9.175 netmask 255.255.255.0 broadcast 192.168.9.255 inet fe80::20c:e7ff:fe11:3d46 netmask ffff:ffff:ffff:ffff:: hwaddr 00:0c:e7:11:3d:46Or ping:iex&gt; ping &quot;nerves-project.com&quot; Press enter to stop Response from nerves-project.com (96.126.123.244): time=48.87ms Response from nerves-project.com (96.126.123.244): time=42.856ms Response from nerves-project.com (96.126.123.244): time=43.097msYou can also specify an interface to use with ping:iex&gt; ping &quot;nerves-project.com&quot;, ifname: &quot;wlan0&quot; Press enter to stop Response from nerves-project.com (96.126.123.244): time=57.817ms Response from nerves-project.com (96.126.123.244): time=46.796ms iex&gt; ping &quot;nerves-project.com&quot;, ifname: &quot;eth0&quot; Press enter to stop Response from nerves-project.com (96.126.123.244): time=47.923ms Response from nerves-project.com (96.126.123.244): time=48.688msIf it looks like nothing is working, check the logs. On Nerves devices, this is frequently done by calling RingLogger.next or RingLogger.attach.At a last resort, please open a GitHub issue. We would be glad to help. We only have one ask and that is that you get us started with an improvement to our documentation or code so that the next person to run into the issue will have an easier time. Thanks!","ref":"readme.html#debugging","title":"README - Debugging","type":"extras"},{"doc":"VintageNet maintains a key/value store for retrieving information on networking information:iex&gt; VintageNet.get([&quot;interface&quot;, &quot;eth0&quot;, &quot;connection&quot;]) :internet iex&gt; VintageNet.get_by_prefix([]) [ {[&quot;interface&quot;, &quot;eth0&quot;, &quot;connection&quot;], :internet}, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;state&quot;], :configured}, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;type&quot;], VintageNetEthernet}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;connection&quot;], :internet}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;state&quot;], :configured}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;type&quot;], VintageNetWiFi} ]You can also subscribe to keys and receive a message every time it or one its child keys changes:iex&gt; VintageNet.subscribe([&quot;interface&quot;, &quot;eth0&quot;]) :ok iex&gt; flush {VintageNet, [&quot;interface&quot;, &quot;eth0&quot;, &quot;state&quot;], :configuring, :configured, %{}}The message format is {VintageNet, name, old_value, new_value, metadata}Global propertiesPropertyValuesDescriptionavailable_interfaces[eth0, ...]Currently available network interfaces in priority order. E.g., the first one is used by defaultconnection:disconnected, :lan, :internetThe overall network connection status. This is the best status of all interfaces.Common network interface propertiesAll network interface properties can be found under [&quot;interface&quot;, ifname] in the PropertyTable. The following table lists out properties common to all interfaces:PropertyValuesDescriptiontypeVintageNetEthernet, etc.The type of the interfaceconfig%{...}The configuration for this interfacestate:configured, :configuring, etc.The state of the interface from VintageNet's point of view.hw_path&quot;/devices/platform/ocp/4a100000.ethernet&quot;This is how Linux internally views the connections going to the interface.connection:disconnected, :lan, :internetThis provides a determination of the Internet connection statuslower_uptrue or falseThis indicates whether the physical layer is &quot;up&quot;. E.g., a cable is connected or WiFi associatedmac_address&quot;11:22:33:44:55:66&quot;The interface's MAC address as a stringaddresses[address_info]This is a list of all of the addresses assigned to this interfaceSpecific types of interfaces provide more parameters.Predictable network interface namesWhen using more than one of the same type of interface, it's possible for Linux to reorder their naming. For example, if you have two USB WiFi adapters, one will be named wlan0 and the other wlan1. Which one is first depends on things like when the adapter is found and when kernel modules are loaded. This can vary between boots and cause a lot of confusion.The solution is to rename network interfaces based on characteristics of the interface - such as how it's connected. Then application software refers to the new name rather than names like wlan0. This is a common problem, and VintageNet provides support for automatically renaming network interfaces.If you're used to systemd's approach to naming interfaces, be aware that VintageNet's approach is different: systemd has an algorithm for generating names (e.g., enp4s0) automatically. VintageNet requires you to provide the names to use (e.q., internet0, lan0, etc.) and how they map to hardware. If VintageNet is confronted with a network interface that is connected in a way that it doesn't know about, it will do nothing.IMPORTANT: Do not mix and match predictable interface names and non-predictable interface names (wlan*, eth*, usb*, wwan*). It is confusing and VintageNet will fight you.Before switching to predictable names, find out how your network interfaces are connected. For example, this device has an Ethernet interface and two USB WiFi dongles:iex&gt; VintageNet.match([&quot;interface&quot;, :_, &quot;hw_path&quot;]) [ {[&quot;interface&quot;, &quot;eth0&quot;, &quot;hw_path&quot;], &quot;/devices/platform/ocp/4a100000.ethernet&quot;}, {[&quot;interface&quot;, &quot;lo&quot;, &quot;hw_path&quot;], &quot;/devices/virtual&quot;}, {[&quot;interface&quot;, &quot;wlan0&quot;, &quot;hw_path&quot;], &quot;/devices/platform/ocp/47400000.usb/47401c00.usb/musb-hdrc.1/usb2/2-1/2-1:1.0&quot;}, {[&quot;interface&quot;, &quot;wlan1&quot;, &quot;hw_path&quot;], &quot;/devices/platform/ocp/47400000.usb/47401400.usb/musb-hdrc.0/usb1/1-1/1-1:1.4&quot;} ]Now update your config.exs with the mappings with the :ifnames key. Be sure to also update the default configuration with the new interface names. Continuing the example, imagine that one WiFi adapter supports 802.11 meshing and it's guaranteed to be in one USB port on the device. The other USB port can have any of a few types of USB WiFi modules. We need to use predictable naming in this case so that meshing is only setup on the adapter that supports it.config :vintage_net, ifnames: [ %{ hw_path: &quot;/devices/platform/ocp/4a100000.ethernet&quot;, ifname: &quot;ethernet0&quot; }, %{ hw_path: &quot;/devices/platform/ocp/47400000.usb/47401c00.usb/musb-hdrc.1/usb2/2-1/2-1:1.0&quot;, ifname: &quot;primary_wifi&quot; }, %{ hw_path: &quot;/devices/platform/ocp/47400000.usb/47401400.usb/musb-hdrc.0/usb1/1-1/1-1:1.4&quot;, ifname: &quot;mesh_wifi&quot; } ], config: [ {&quot;ethernet0&quot;, %{type: VintageNetEthernet}}, {&quot;primary_wifi&quot;, %{type: VintageNetWiFi}}, {&quot;mesh_wifi&quot;, %{type: VintageNetWiFi}} ]IMPORTANT: VintageNet has rules about renaming interfaces to prevent confusing errors. Below is a list of reasons it will not rename an interfacehw_path matches /devices/virtual (such as lo0, ppp0 etc.)A second interface's hw_path matches an interface that has already been renamed. This should never happen.","ref":"readme.html#properties","title":"README - Properties","type":"extras"},{"doc":"Some devices require additional work to be done for them to become available. Examples of this are:Setting a GPIO to enable power to the moduleLoading a Linux kernel module that is not automatically loaded via the default mechanismsRunning usb_modeswitch to change the USB interface to the appropriate statePerforming an initialization step such as loading firmwareSimilarly, when the network interface is no longer being used, it can be nice to undo any steps above.This process is referred to as power management in VintageNet even though the implementation may not actually affect power use. To use it, implement the VintageNet.PowerManager behaviour and register the implementation in your config.exs.Additionally, VintageNet runs a watchdog-like service for network devices that supply VintageNet.PowerManager implementations. If the watchdog is not pet within the timeout period (user-specified and defaults to 60 seconds), VintageNet powers the device off and and on. The VintageNet power management code supports mandatory minimum on and off times to prevent damage to hardware and also minimize pointless power cycling of hardware.While many network devices are fairly reliable and powering off and on seems unnecessary, it can save a trip to the field or a full device reboot.VintageNet.info/1 shows the power management state for network interfaces that are using this feature.","ref":"readme.html#power-management","title":"README - Power Management","type":"extras"},{"doc":"VintageNet CookbookNot sure what to pass to vintage_net? Take a look below for example configurations.","ref":"cookbook.html","title":"VintageNet Cookbook","type":"extras"},{"doc":"The examples below all show the options to pass. Where you copy those depends on whether you want the configuration to be a built-in default (i.e., compile-time) or whether you want to change it at run-time.For compile-time, add something like the following to your config.exs:config :vintage_net, config: [ {&quot;eth0&quot;, %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}}, ]But replace &quot;eth0&quot; with the interface and the map with the desired configuration from below.For run-time, call VintageNet.configure like this:VintageNet.configure(&quot;eth0&quot;, %{type: VintageNetEthernet, ipv4: %{method: :dhcp}})To see the current configuration at an IEx prompt, type:iex&gt; VintageNet.info","ref":"cookbook.html#compile-time-vs-run-time","title":"VintageNet Cookbook - Compile-time vs. run-time","type":"extras"},{"doc":"In order to configure a network interface, you will need to know its name. vintage_net passes names through from Nerves or embedded Linux depending on where it's being run. The following names are common:&quot;eth0&quot; - The first wired Ethernet interface&quot;wlan0&quot; - The first WiFi interface&quot;usb0&quot; - The first virtual Ethernet interface over a USB cableThe operating system assigns network interface names as it discovers them. If you're running on a device with multiple of the same type of interface, the device names may be renamed to make them deterministic. An example is &quot;enp6s0&quot; where the p6 and s0 indicate where the adapter and Ethernet connector location. Running ifconfig on Linux and Nerves can help find these if you are unsure.","ref":"cookbook.html#network-interface-names","title":"VintageNet Cookbook - Network interface names","type":"extras"},{"doc":"To use, make sure that you're either using nerves_pack or have :vintage_net_ethernet in your deps: {:vintage_net_ethernet, &quot;~&gt; 0.8&quot;}Wired Ethernet with DHCPThis is regular wired Ethernet - nothing fancy:%{type: VintageNetEthernet, ipv4: %{method: :dhcp}}Wired Ethernet with a static IPUpdate the parameters below as appropriate:%{ type: VintageNetEthernet, ipv4: %{ method: :static, address: &quot;192.168.9.232&quot;, prefix_length: 24, gateway: &quot;192.168.9.1&quot;, name_servers: [&quot;1.1.1.1&quot;] } }See VintageNet.IP.IPv4Config for other options. If you're interfacing with other Erlang and Elixir libraries, you may find passing IP tuples more convenient than passing strings. That works too.","ref":"cookbook.html#wired-ethernet","title":"VintageNet Cookbook - Wired Ethernet","type":"extras"},{"doc":"To use, make sure that you're either using nerves_pack or have :vintage_net_wifi in your deps: {:vintage_net_wifi, &quot;~&gt; 0.8&quot;}Normal password-protected WiFi (WPA2 PSK)Most password-protected home networks use WPA2 authentication and pre-shared keys.%{ type: VintageNetWiFi, vintage_net_wifi: %{ networks: [ %{ key_mgmt: :wpa_psk, ssid: &quot;my_network_ssid&quot;, psk: &quot;a_passphrase_or_psk&quot; } ] }, ipv4: %{method: :dhcp}, }Enterprise WiFi (PEAPv0/EAP-MSCHAPV2)Protected EAP (PEAP) is a common authentication protocol for enterprise WiFi networks.%{ type: VintageNetWiFi, vintage_net_wifi: %{ networks: [ %{ key_mgmt: :wpa_eap, ssid: &quot;my_network_ssid&quot;, identity: &quot;username&quot;, password: &quot;password&quot;, eap: &quot;PEAP&quot;, phase2: &quot;auth=MSCHAPV2&quot; } ] }, ipv4: %{method: :dhcp} }Enterprise WiFi (EAP-TLS)TBDAccess point WiFiSome WiFi modules can be run in access point mode. This makes it possible to create configuration wizards and captive portals. Configuration of this is more involved. Here is a basic configuration:%{ type: VintageNetWiFi, vintage_net_wifi: %{ networks: [ %{ mode: :ap, ssid: &quot;test ssid&quot;, key_mgmt: :none } ] }, ipv4: %{ method: :static, address: &quot;192.168.24.1&quot;, netmask: &quot;255.255.255.0&quot; }, dhcpd: %{ start: &quot;192.168.24.2&quot;, end: &quot;192.168.24.10&quot; } }See the vintage_net_wizard for an example of a project that uses AP mode and a web server for WiFi configuration.Bridged Mesh WiFiIn addition to infrastructure and AP modes, some WiFi modules can form a mesh. VintageNet supports the configuration of 802.11s meshes. While this is the standardize way of forming WiFi meshes, it is not the same as that implemented by many access points that advertise WiFi meshing. It also uses the 802.11s routing protocol HWMP. (This is not B.A.T.M.A.N.).This section describes two configuration: the first is for the mesh gate and the second is for the mesh devices. The mesh gate bridges the mesh network to the network that connects to the Internet. Mesh nodes behave similar to normal clients: after connecting to the network, they request an IP address using DHCP. The DHCP request gets routed through the mesh gate and to the DHCP server on the non-mesh LAN. It's possible to have multiple mesh gates. Routing through the mesh and the mesh gate is transparent.The following configuration is for a mesh gate with one WiFi interface used for the mesh network and a wired network interface, eth0, that connects it to the LAN:mesh0_config = %{ type: VintageNetWiFi, vintage_net_wifi: %{ user_mpm: 1, # mesh creates a &quot;virtual&quot; interface based on # this interface name root_interface: &quot;wlan0&quot;, networks: [ %{ key_mgmt: :none, ssid: &quot;my-mesh&quot;, frequency: 2432, mode: :mesh } ] }, # we don&#39;t need an ip address on the mesh interface ipv4: %{method: :disabled}, } # Bridge configured to bridge eth0 and mesh0 together br0_config = %{ type: VintageNetBridge, ipv4: %{method: :dhcp}, vintage_net_bridge: %{ interfaces: [&quot;eth0&quot;, &quot;mesh0&quot;] } } eth0_config = %{ type: VintageNetEthernet, # the bridge handles ip addressing ipv4: %{method: :disabled}, } VintageNet.configure(&quot;mesh0&quot;, mesh0_config) VintageNet.configure(&quot;br0&quot;, br0_config) VintageNet.configure(&quot;eth0&quot;, eth0_config)This configuration is for devices on the mesh:mesh0_config = %{ type: VintageNetWiFi, vintage_net_wifi: %{ user_mpm: 1, # mesh creates a &quot;virtual&quot; interface based on # this interface name root_interface: &quot;wlan0&quot;, networks: [ %{ key_mgmt: :none, ssid: &quot;my-mesh&quot;, frequency: 2432, mode: :mesh } ] }, # the mesh is bridged on the other # device, so we can use dhcp now ipv4: %{method: :dhcp}, } VintageNet.configure(&quot;mesh0&quot;, mesh0_config)","ref":"cookbook.html#wifi","title":"VintageNet Cookbook - WiFi","type":"extras"},{"doc":"Share WAN with other networksFor sharing your WAN connection (e.g. internet access) with other networks iptables must be installed. Currently this means building a custom nerves system. Once this is done the following commands need to be called on each boot:wan = &quot;eth0&quot; cmd &quot;sysctl -w net.ipv4.ip_forward=1&quot; cmd &quot;iptables -t nat -A POSTROUTING -o \#{wan} -j MASQUERADE&quot; # Only needed if the connection is blocked otherwise (like a default policy of DROP) cmd &quot;iptables -A INPUT -i \#{wan} -m state --state RELATED,ESTABLISHED -j ACCEPT&quot;","ref":"cookbook.html#network-interaction","title":"VintageNet Cookbook - Network interaction","type":"extras"},{"doc":"Temporarily disable WiFiVintageNet persists configurations by default. Sometimes you just want to disable a network temporarily and then if the device reboots, it reboots to the old configuration. The :persist option let's you do this:VintageNet.deconfigure(&quot;wlan0&quot;, persist: false)To get the old configuration back, you have to call VintageNet.configure/3 with it again (or restart VintageNet or reboot).Perform some initialization to turn on a network interfaceVintageNet waits for network interfaces to appear before doing any work. If you need to perform some work to make the network interface show up, that has to be done elsewhere. If you let VintageNet know about this work and allow it to turn the network interface off too, it can &quot;cycle power&quot; to the interface to get it back to a clean state when needed. Here's how:defmodule MyPowerManager do @behaviour VintageNet.PowerManager @reset_n_gpio 4 @power_on_hold_time 5 * 60000 @min_powered_off_time 5000 defstruct reset_n: nil @impl VintageNet.PowerManager def init(_args) do {:ok, reset_n} = Circuits.GPIO.open(@reset_n_gpio, :output) {:ok, %__MODULE__{reset_n: reset_n}} end @impl VintageNet.PowerManager def power_on(state) do # Do whatever is necessary to turn the network interface on Circuits.GPIO.write(state.reset_n, 1) {:ok, state, @power_on_hold_time} end @impl VintageNet.PowerManager def start_powering_off(state) do # If there&#39;s a graceful power off, start it here and return # the max time it takes. {:ok, state, 0} end @impl VintageNet.PowerManager def power_off(state) do # Disable the network interface Circuits.GPIO.write(state.reset_n, 0) {:ok, state, @min_powered_off_time} endThen add the following to your config.exs:config :vintage_net, power_managers: [{MyPowerManager, ifname: &quot;wlan0&quot;}]VintageNet determines whether devices are ok by use of a watchdog. VintageNet and its technology implementations pet the watchdog by calling VintageNet.PowerManager.PMControl.pet_watchdog/1. This may be insufficient for your application. Options include calling that function in your code regularly or modifying the :watchdog_timeout in the power manager spec in your config.exs.See VintageNet.PowerManager for details.","ref":"cookbook.html#common-tasks","title":"VintageNet Cookbook - Common tasks","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fixesBe more robust to PowerManager.init/1 failures. While this function shouldn't raise, the effect of it raising was particularly destructive to VintageNet and took down networking.Update gen_state_machine dependency to let the 3.0.0 release be used.","ref":"changelog.html#v0-9-3","title":"Changelog - v0.9.3","type":"extras"},{"doc":"Bug fixesHandle missing commands as errors rather than raising. This makes it a little easier test vintage_net and libraries that use it.Fixes @doc tag warnings during compile time","ref":"changelog.html#v0-9-2","title":"Changelog - v0.9.2","type":"extras"},{"doc":"Bug fixesThis fixes an issue where system networking binaries were not being resolved according to vintage_net's view of the PATH. vintage_net looks in the standard directories by default, but it's possible to restrict or add locations.","ref":"changelog.html#v0-9-1","title":"Changelog - v0.9.1","type":"extras"},{"doc":"This release contains improvements that will not affect you unless you are using a custom VintageNet.Technology implementation.New featuresAdd power management support. This adds support for powering on and off network devices and also enables VintageNet to restart devices that are not working (if allowed). See VintageNet.PowerManager for details.Breaking changesPaths to networking programs like wpa_supplicant are no longer passed as opts during configuration. I.e., :bin_wpa_supplicant, :bin_ip, etc. This was not a generally useful feature since it wasn't possible to include all possible programs. A future plan is to add support for verifying that networking programs exist before trying to configure an interface. Programs should be passed as strings now.Support for the :busybox hex package has been removed. This was useful when networking programs were unavailable on a system, but all official Nerves systems have included them for the past year and :busybox required maintenance to keep working and up-to-date.","ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras"},{"doc":"New features[Breaking change for technology implementors] Decouple the network interface name from the one a network technology uses. For example, cellular modems can now have vintage_net wait for wwan0 to appear before setting up a PPP interface (like ppp0). All network technology implementations need to be updated to provide RawConfigs that list the network interfaces they need to start. This is hard to miss since you'll get a compile error if it affects you.Deterministic interface naming support - If you have a device with multiple network interfaces of the same type (e.g., multiple WiFi adapters) it is possible for them to switch between being assigned wlan0 and wlan1 under some conditions. This feature allows you to map their hardware location to a name of your choosing. See the README.md for details.Add the &quot;hw_path&quot; property - For example, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;hw_path&quot;], &quot;/devices/platform/ocp/4a100000.ethernet&quot;}Bug fixesStop network interface management GenServers before running the &quot;down&quot; commands. This is most noticeable in reduced log noise on network hiccups and device removals.","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"Bug fixesFix IP address being reported for PPP connections. Previously, it was the remote end of the PPP connection rather than the local end.Fix missing IPv6 address reports. Depending on when IPv6 addresses were set on network interfaces, they might not have been reported. Note that IPv6 isn't officially supported by VintageNet yet.","ref":"changelog.html#v0-7-9","title":"Changelog - v0.7.9","type":"extras"},{"doc":"ImprovementsStore an interface's configuration in the [&quot;interface&quot;, ifname, &quot;config&quot;] property. This makes it possible to subscribe to configuration changes (like any other property).Print out IP addresses with VintageNet.info/0Bug fixesFixed VintageNet.get_configuration/1 to return the configuration that will be applied even if it's not the configuration that's currently applied. The previous semantics would break code that made decisions based on the current configurations.","ref":"changelog.html#v0-7-8","title":"Changelog - v0.7.8","type":"extras"},{"doc":"ImprovementsAdded time-in-state to VintageNet.info. This lets you see if a connection has bounced at a glance without digging through the logs.","ref":"changelog.html#v0-7-7","title":"Changelog - v0.7.7","type":"extras"},{"doc":"Bug fixesEnsure that Technology.normalize/1 is always called. Previously, this wasn't guaranteed, and it could result in a surprise when an unnormalized configuration got saved.Remove duplicate resolv.conf entries on multi-homed devicesFix warnings found by Elixir 1.10","ref":"changelog.html#v0-7-6","title":"Changelog - v0.7.6","type":"extras"},{"doc":"Bug fixesFix routing table error when configuring multiple interfaces of the same type.Fix VintageNet.info for when it's called before vintage_net is loaded.","ref":"changelog.html#v0-7-5","title":"Changelog - v0.7.5","type":"extras"},{"doc":"Bug fixesFix VintageNet.info crash when displaying AP mode configurationsSave configurations using the :sync flag to reduce the chance that they're lost on ungraceful power offs. I.e., people pulling the power cable after device configuration.","ref":"changelog.html#v0-7-4","title":"Changelog - v0.7.4","type":"extras"},{"doc":"ImprovementsScrub VintageNet.info/0 output to avoid accidental disclosure of WiFi credentialsSupport options to deconfigure/2 to mirror those on configure/2Prefix udhcpc logs with interface to more easily blame problematic networksSupport IPv4 /32 subnetsVarious documentation fixes and improvements","ref":"changelog.html#v0-7-3","title":"Changelog - v0.7.3","type":"extras"},{"doc":"Bug fixRemove noisy log message introduced in v0.7.1","ref":"changelog.html#v0-7-2","title":"Changelog - v0.7.2","type":"extras"},{"doc":"This release fixes an issue where the Internet-connectivity checking code could crash. It was automatically restarted, but that had a side effect of delaying a report that the device was connected AND breaking mdns_lite. Both the crash and the restart issue were fixed. The mdns_lite side effect was due to its multicast group membership being lost so this would affect other multicast-using code.Bug fixesFix :timeout_value crash in the InternetConnectivityCheckerForce clear IPv4 addresses when the DHCP notifies a deconfig event. This occurs on a restart and is quickly followed by a renew. However, if applications don't see this, bounce and don't register their multicast listeners on affected IPv4 address again, they'll lose the subscription.ImprovementsAdded check for nerves_network and nerves_init_gadget. If your project pulls these in, it will get a moderately friendly notice to remove them.","ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras"},{"doc":"This release moves network technology implementations (WiFi, wired Ethernet, etc.) into their own projects. This means that they can evolve at their own pace. It also means that we're finally ready to support the VintageNet.Technology behaviour as part of the public API so that VintageNet users can add support for network technologies that we haven't gotten to yet.IMPORTANT: This change is not backwards compatible. You will need to update existing projects to bring in a new dependency. The runtime is backwards compatible. I.e., If you have a networking configuration saved in VintageNet, it will be updated on load. It won't be re-saved, so if you need to revert an update, it will still work. The next save, though, will use the new naming.If you're using VintageNet.Technology.Gadget, do the following:Add {:vintage_net_direct, &quot;~&gt; 0.7.0&quot;} to your mix.exs dependencies. You'll notice that references to &quot;gadget&quot; have been replaced with the word &quot;direct&quot;. We think the new naming is more accurate.Replace all references to VintageNet.Technology.Gadget in your code to VintageNetDirect. Be aware of aliases and configuration.If you passed options when configuring the network, the :gadget key is now :vintage_net_direct. Most users don't pass options.If you're using VintageNet.Technology.Ethernet, do the following:Add {:vintage_net_ethernet, &quot;~&gt; 0.7.0&quot;} to your mix.exs dependencies.Replace all references to VintageNet.Technology.Ethernet in your code to VintageNetEthernet. Be aware of aliases and configuration.If you're using VintageNet.Technology.WiFi, do the following:Add {:vintage_net_wifi, &quot;~&gt; 0.7.0&quot;} to your mix.exs dependencies.Replace all references to VintageNet.Technology.WiFi in your code to VintageNetWiFi. Be aware of aliases and configuration. Also, the &quot;F&quot; is capital.The :wifi key in the network configuration is now :vintage_net_wifi.","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Bug fixesFix warning from Dialyzer when making wild card subscriptions. Code was also added to more thoroughly validate properties paths to raise on subtle issues that won't do what the programmer intends.New featuresAdded VintageNet.match/1 to support &quot;gets&quot; on properties using wildcards.","ref":"changelog.html#v0-6-6","title":"Changelog - v0.6.6","type":"extras"},{"doc":"New featuresSupport wild card subscriptions to properties. This makes it possible to subscribe to things like [&quot;interface&quot;, :_, &quot;addresses&quot;] where the :_ indicates that any value in the second position should match. That particular subscription would send a message whenever an IP address anywhere gets added, changed, or removed.","ref":"changelog.html#v0-6-5","title":"Changelog - v0.6.5","type":"extras"},{"doc":"ImprovementsAdded the [&quot;interface&quot;, ifname, &quot;eap_status&quot;] property for EAP events. EAP is currently only supported on WiFi, but is anticipated for wired Ethernet too.","ref":"changelog.html#v0-6-4","title":"Changelog - v0.6.4","type":"extras"},{"doc":"This release renames the WiFi mode names. The old names still work so it's a backwards compatible update. The new names are :ap and :infrastructure instead of :host and :client. These names match the mode names in the IEEE specifications and usage elsewhere.New featuresSupport static IPv4 configurations for a default gateway and list of name resolvers. See :gateway and :name_servers parameters.Support ad-hoc WiFi networking (IBSS mode)","ref":"changelog.html#v0-6-3","title":"Changelog - v0.6.3","type":"extras"},{"doc":"New featuresSupport running a simple DNS server on an interface. This was added for WiFi AP mode configuration and could be useful for other scenarios.Support DHCP server response optionsSupport disabling configuration persistence on a per-call basis. This is for temporary configurations where a reboot should not preserve the setting. For example, VintageNet.configure(&quot;wlan0&quot;, config, persist: false)","ref":"changelog.html#v0-6-2","title":"Changelog - v0.6.2","type":"extras"},{"doc":"New featuresAdd a current_ap property for WiFi interfaces so that programs can get information about the currently associated access pointSupport running a DHCP server on wired Ethernet interfacesExpose VintageNet.WiFi.WPA2.validate_passphrase/1 so that applications can reuse the WiFI passphrase validation logic. This logic follows IEEE Std 802.11i-2004 and validates things like proper length and character set","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"IMPORTANT: This release contains a LOT of changes. VintageNet is still pre-1.0 and we're actively making API changes as we gain real world experience with it. Please upgrade carefully.Incompatible changesAll IP addresses are represented as tuples. You can still specify IP addresses as strings, like &quot;192.168.1.1&quot;, but it will be converted to tuple form. When you get the configuration, you'll see IP addresses as tuples. This means that if you save your configuration and revert to a previous version of VintageNet, the settings won't work.WiFi network configuration is always under the :networks key. This was inconsistent. Configuration normalization will update old saved configurations.Support for the IPv4 broadcast IP address has been removed. Existing support was incomplete and slightly confusing, so we decided to remove it for now.All IP address subnets are represented by their prefix length. For example, 255.255.255.0 is recorded as a subnet with prefix length 24. Configuration normalization converts subnet masks to prefix length now.New featuresUSB gadget support - See VintageNet.Technology.Gadget. It is highly likely that we'll refactor USB gadget support to its own project in the future.Add :verbose key to configs for enabling debug messages from third party applications. Currently :verbose controls debug output from wpa_supplicant.Allow users to pass additional options to MuonTrap so that it's possible to run network daemons in cgroups (among other things)Bug fixesNetworking daemons should all be supervised now. For example, udhcpc previously was started by ifup and under many conditions, it was possible to get numerous instances started simultaneously. Plus failures weren't detected.No more killall calls to cleanup state. This had prevented network technologies from being used on multiple interfaces.No more ifupdown. This was very convenient for getting started, but has numerous flaws. Search the Internet for rants. This was replaced with direct calls to ip link and ip addr and adding network daemons to supervision trees.Known issuesStatic IP addressing is still not implemented. It's only implemented enough for WiFi AP mode and USB gadget mode to work. We hope to fix this soon.It's not possible to temporarily configure network settings. At the moment, if persistence is enabled (the default), configuration updates are always saved.","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Bug fixesAdd missing PSK conversion when configuring multiple WiFi networks. This fixes a bug where backup networks wouldn't connect.ImprovementsDon't poll WiFi networks that are configured for AP mode for Internet. They will never have it.Reduce the number of calls to update routing tables. Previously they were unnecessarily updated on DHCP failures due to timeouts. This also removes quite a bit of noise from the log.Filter out interfaces with &quot;Null&quot; technologies on them from the configured list. They really aren't configured so it was confusing to see them.","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"Backwards incompatible change: The WiFi access point property (e.g., [&quot;interfaces&quot;, &quot;wlan0&quot;, &quot;access_points&quot;]) is now a simple list of access point structs. It was formerly a map and code using this property will need to be updated.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"},{"doc":"ImprovementsSupport run-time configuration of regulatory domainError message improvement if build system is missing pkg-config","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"Build note: The fix to support AP scanning when in AP-mode (see below) required pulling in libnl-3. All official Nerves systems have it installed since it is required by the wpa_supplicant. If you're doing host builds on Linux, you'll need to run apt install libnl-genl-3-dev.New featuresReport IP addresses in the interface properties. It's now possible to listen for IP address changes on interfaces. IPv4 and IPv6 addresses are reported.Support scanning for WiFi networks when an WiFi module is in AP mode. This lets you make WiFi configuration wizards. See the vintage_net_wizard project.Add interface MAC addresses to the interface propertiesBug fixesSome WiFi adapters didn't work in AP mode since their drivers didn't support the P2P interface. Raspberry Pis all support the P2P interface, but some USB WiFi dongles do not. The wpa_supplicant interface code was updated to use fallback to the non-P2P interface in AP mode if it wasn't available.","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"New featuresAdd null persistence implementation for devices migrating from Nerves Network that already have a persistence strategy in place","ref":"changelog.html#v0-3-1","title":"Changelog - v0.3.1","type":"extras"},{"doc":"New featuresSupport the busybox hex.pm package to bring in networking support if not present in the Nerves system image. This enables use with the minimal official Nerves images.Add Unix domain socket interface to the wpa_supplicant. This enables much faster scanning of WiFi networks and other things like collecting attached clients when in AP-mode and pinging the supplicant to make sure it's running.Log output of commandline-run applications so that error messages don't get lost.Provide utilities for reporting WiFi signal strength as a percent to end users.Bug fixesSupport scanning WiFi access points with Unicode names (emoji, etc. in their SSIDs)Allow internet connectivity pings to be missed 3 times in a row before deciding that the internet isn't reachable. This avoids transients due to the random dropped packet.Reduce externally visible transients due to internal GenServers crashing and restarting - also addressed the crashesSupport configure while configuring - let's you cancel a configuration that takes a long time to apply and apply a new one","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"New featuresListen for interface additions and physical layer notifications so that routing and status updates can be made much more quicklyAdd lower_up to the interface properties","ref":"changelog.html#v0-2-4","title":"Changelog - v0.2.4","type":"extras"},{"doc":"Bug fixesThis release fixes supervision issues so that internal VintageNet crashes can be recoveredVintageNet.get_configuration/1 works now&quot;available_interfaces&quot; is updated again","ref":"changelog.html#v0-2-3","title":"Changelog - v0.2.3","type":"extras"},{"doc":"Bug fixesFix local LAN routing","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"New featuresExpose summary status of whether the whole device is disconnected, LAN-connected, or Internet-connected","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"New featuresSupport WiFi AP mode - see README.md for exampleBug fixesAlway update local routes before default routes to avoid getting errors when Linux detects a table entry that cannot be routed","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"Initial release to hex.","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]